#include "forms.h"
#include "convection.h"
#include "create_movie.c"

int movie_key_w = 0;
double reynolds_number = 500.0, run_time = 20, vfieldparm = 0.5;

/*** callbacks and freeobj handles for form Convection ***/

void Reyno(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  
  reynolds_number = atof(fl_get_input(ob)); 

  printf("Reynolds Number = %g \n", reynolds_number);
}

void r_time(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  run_time = atof(fl_get_input(ob)); 

  printf("Running Time = %g \n", run_time);
}

void mag_fiel_conf(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Not yet implemented \n");
}

void vf_p(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  
  vfieldparm = atof(fl_get_input(ob)); 

  printf("M = %g \n", vfieldparm);
}

void drawing(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  FILE *xpcellpar;

  xpcellpar = fopen("PAR", "w");

  fprintf(xpcellpar, "%lf %lf %d %d \n", reynolds_number, vfieldparm, 
	  ((int) run_time), movie_key_w); 

  fclose(xpcellpar);

  system("./convection");
}

void redrawing(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  system("./convection");
}

void streaming(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */
  
  FILE *xpcellst;

  xpcellst = fopen("ST", "w");

  fprintf(xpcellst, "%lf \n", vfieldparm); 

  fclose(xpcellst);

  system("./stream");
}

void make_movie(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  movie_key_w = TRUE;

  FILE *xpcellpar;

  xpcellpar = fopen("PAR", "w");

  fprintf(xpcellpar, "%lf %lf %d %d \n", reynolds_number, vfieldparm, 
	  ((int) run_time), movie_key_w); 

  fclose(xpcellpar);
  
  system("./convection");
  create_movie(run_time);
  system("chmod +x make-movie");
  system("./make-movie");

  movie_key_w = FALSE;

  xpcellpar = fopen("PAR", "w");

  fprintf(xpcellpar, "%lf %lf %d %d \n", reynolds_number, vfieldparm, 
	  ((int) run_time), movie_key_w); 

  fclose(xpcellpar);
}

void helping(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  printf("Not yet implemented \n");
}

void quit(FL_OBJECT *ob, long data)
{
  /* fill-in code for callback */

  fl_finish();
  exit(0); 
}

